library stevenroose.json_rpc_2_client;

import "dart:async";

import "dart:io" deferred as io;
import "dart:html" deferred as html;

import "package:json_rpc_2/json_rpc_2.dart" as json_rpc;


class JsonRpc2Client implements json_rpc.Client {

  Future<json_rpc.Client> _client;

  AsyncJsonClient(String clientAddress) {
    Uri clientUri = Uri.parse(clientAddress);
    _client = io.loadLibrary().then((_) {
      // use io
      if(clientUri.scheme == "ws") {
        // WebSocket
        return io.WebSocket.connect(clientAddress).then((socket) {
          return new json_rpc.Client(socket);
        });
      } else {
        // HTTP
        io.HttpClient client = new io.HttpClient();

      }
    }, onError: (error) {
      if(error is! DeferredLoadException)
        throw error;
      // use html
      return html.loadLibrary().then((_) {

      });
    });
  }

}